//
//  QBMSubscription.h
//  MessagesService
//

//  Copyright 2010 QuickBlox team. All rights reserved.
//

/** QBMSubscription class declaration. */
/** Overview */
/** Class represents user subscription to push chanell */

@interface QBMSubscription : Entity {
	QBMNotificatioChannel notificationChannel;
	NSString *deviceUDID;
    NSString *devicePlatform;
    NSString *url;
}
/** Declare which notification channels could be used to notify user about events. */
@property (nonatomic) QBMNotificatioChannel notificationChannel;

/** Device UDID */
@property (nonatomic, retain) NSString *deviceUDID;

/** Device platform name */
@property (nonatomic, retain) NSString *devicePlatform;

/** Url parameter have to be set in case of using http_request type notification_channel. This url will be posted with event data when event occurs. */
@property (nonatomic, retain) NSString *url;


#pragma mark -
#pragma mark Converters

+ (enum QBMNotificatioChannel)notificationChannelFromString:(NSString *)notificationChannel;
+ (NSString *)notificationChannelToString:(enum QBMNotificatioChannel)notificationChannel;

@end
